// m:  
//  1.0  29.04.2014

function MainBalls(canvas) {

    //  

    var context = canvas.getContext("2d");  //  context  

    const Pi = 3.1415926;                   //  ""

    const m0 = 1;                           //  
    const T0 = 1;                           //   (   )
    const a0 = 1;                           //   ( )

    const g0 = a0 / T0 / T0;                //   (,    T0    a0)
    const k0 = 2 * Pi / T0;                 //  
    const C0 = m0 * k0 * k0;                //  
    const B0 = 2 * m0 * k0;                 //  

    // ***    ***

    const Ny = 5;                           //  ,      (     )
    const m = 1 * m0;                       // 
    const Cwall = 10 * C0;                  //  
    const B = 0.008 * B0;                   //  
    const B1 = 0.03 * B0;                   //   
    const mg = 0.25 * m * g0;               //  
    const r = 0.5 * a0;                     //     

    // ***    ***

    const fps = 50;                         // frames per second -     ( )
    const spf = 100;                        // steps per frame   -      ( )
    const dt  = 0.045 * T0 / fps;           //   ( )

    //  

    const scale = canvas.height / Ny / a0;  //         

    var w = canvas.width / scale;           //     
    var h = canvas.height / scale;          //     

    //  

    var b = [];
    b.x = w / 2;            b.y = h / 2;    //   
    b.fx = 0;               b.fy = mg;      // ,   
    b.vx = 3;               b.vy = -1.5;    //  

    //   

    function control() {
        physics();
        draw();
    }

    //   

    function physics() {                    // ,     
        for (var s = 1; s <= spf; s++) {
            b.fx = - B * b.vx;
            b.fy = mg - B * b.vy;

            if (b.y + r > h) { b.fy += -Cwall * (b.y + r - h) - B1 * b.vy; }
            if (b.y - r < 0) { b.fy += -Cwall * (b.y - r) - B1 * b.vy;}
            if (b.x + r > w) { b.fx += -Cwall * (b.x + r - w) - B1 * b.vx; }
            if (b.x - r < 0) { b.fx += -Cwall * (b.x - r) - B1 * b.vx; }

            b.vx += b.fx / m * dt;        b.vy += b.fy / m * dt;
            b.x += b.vx * dt;             b.y += b.vy * dt;
        }
    }

    // 

    context.fillStyle = "#3070d0";                          // 
    function draw() {
        context.clearRect(0, 0, w * scale, h * scale);      //  
            context.beginPath();
            context.arc(b.x * scale, b.y * scale, r * scale, 0, 2 * Math.PI, false);
            context.closePath();
            context.fill();
    }

    setInterval(control, 1000 / fps);                       //  
}